/*
 *  linux/ibcs/bsdioctl.c
 *
 *  Copyright (C) 1994  Mike Jagdis
 *
 * $Id: bsdioctl.c,v 1.2 1994/06/23 15:54:51 mike Exp $
 * $Source: /var/CVS/ibcs/bsdioctl.c,v $
 */
#ifdef EMU_BSD

#include <linux/errno.h>
#include <linux/stat.h>
#include <linux/fs.h>
#include <linux/sched.h>
#include <linux/kernel.h>
#include <linux/sys.h>
#include <linux/termios.h>
#include <linux/time.h>
#include <asm/segment.h>

#include <ibcs/ibcs.h>
#include <ibcs/bsd.h>

#ifdef IBCS_TRACE
#include <ibcs/trace.h>
#endif


int
bsd_ioctl_termios(int fd, unsigned int func, void *arg)
{
	switch (func) {
		case BSD__IO('t', 13):			/* TIOEXCL */
			return SYS(ioctl)(fd, TIOCEXCL, arg);

		case BSD__IO('t', 14):			/* TIOCNXCL */
			return SYS(ioctl)(fd, TIOCNXCL, arg);

		case BSD__IOW('t', 16, int):		/* TIOCFLUSH */
			return SYS(ioctl)(fd, TCFLSH, arg);

		case BSD__IO('t', 97):			/* TIOCSCTTY */
			return SYS(ioctl)(fd, TIOCSCTTY, arg);

		case BSD__IOW('t', 103, struct winsize):	/* TIOCSWINSZ */
			return SYS(ioctl)(fd, TIOCSWINSZ, arg);

		case BSD__IOR('t', 104, struct winsize):	/* TIOCGWINSZ */
			return SYS(ioctl)(fd, TIOCGWINSZ, arg);

		case BSD__IO('t', 113):			/* TIOCNOTTY */
			return SYS(ioctl)(fd, TIOCNOTTY, arg);

		case BSD__IOW('t', 118, int):		/* TIOCSPGRP */
			return SYS(ioctl)(fd, TIOCSPGRP, arg);

		case BSD__IOR('t', 119, int):		/* TIOCGPGRP */
			return SYS(ioctl)(fd, TIOCGPGRP, arg);

		case BSD__IO('t', 123):			/* TIOCSBRK */
			return SYS(ioctl)(fd, TCSBRK, arg);

		case BSD__IOR('t', 3, int):			/* TIOCMODG */
		case BSD__IOW('t', 4, int):			/* TIOCMODS */
		case BSD__IOR('t', 19, struct termios):	/* TIOCGETA */
		case BSD__IOW('t', 20, struct termios):	/* TIOCSETA */
		case BSD__IOW('t', 21, struct termios):	/* TIOCSETAW */
		case BSD__IOW('t', 22, struct termios):	/* TIOCSETAF */
		case BSD__IOR('t', 26, int):		/* TIOCGETD */
		case BSD__IOW('t', 27, int):		/* TIOCSETD */
		case BSD__IO('t', 122):			/* TIOCCBRK */
		case BSD__IO('t', 121):			/* TIOCSDTR */
		case BSD__IO('t', 120):			/* TIOCCDTR */
		case BSD__IOR('t', 115, int):		/* TIOCOUTQ */
		case BSD__IOW('t', 114, char):		/* TIOCSTI */
		case BSD__IOW('t', 112, int):		/* TIOCPKT */
		case BSD__IO('t', 111):			/* TIOCSTOP */
		case BSD__IO('t', 110):			/* TIOCSTART */
		case BSD__IOW('t', 109, int):		/* TIOCMSET */
		case BSD__IOW('t', 108, int):		/* TIOCMBIS */
		case BSD__IOW('t', 107, int):		/* TIOCMBIC */
		case BSD__IOR('t', 106, int):		/* TIOCMGET */
		case BSD__IOW('t', 105, int):		/* TIOCREMOTE */
		case BSD__IOW('t', 102, int):		/* TIOCUCNTL */
		case BSD__IOW('t', 98, int):		/* TIOCCONS */
		case BSD__IOW('t', 96, int):		/* TIOCEXT */
		case BSD__IO('t', 95):			/* TIOCSIG */
		case BSD__IO('t', 94):			/* TIOCDRAIN */
	}

	printk(KERN_ERR "BSD: termios ioctl 0x%08lx unsupported\n",
		(unsigned long)func);
	return -EINVAL;
}

#endif /* EMU_BSD */
